Subject: Re: [PATCH v8 4/5] mac80211_hwsim: add PMSR abort support via virtio

From: Simon Horman <[email-masked]>
Date: Tue, 7 Mar 2023 07:56:36 +0100

On Mon, Mar 06, 2023 at 06:37:14PM +0100, Simon Horman wrote:
> On Thu, Mar 02, 2023 at 04:03:09PM +0000, Jaewan Kim wrote:
> > PMSR (a.k.a. peer measurement) is generalized measurement between two
> > devices with Wi-Fi support. And currently FTM (a.k.a. fine time
> > measurement or flight time measurement) is the one and only measurement.
> > 
> > Add necessary functionalities for mac80211_hwsim to abort previous PMSR
> > request. The abortion request is sent to the wmedium where the PMSR request
> > is actually handled.
> > 
> > In detail, add new mac80211_hwsim command HWSIM_CMD_ABORT_PMSR. When
> > mac80211_hwsim receives the PMSR abortion request via
> > ieee80211_ops.abort_pmsr, the received cfg80211_pmsr_request is resent to
> > the wmediumd with command HWSIM_CMD_ABORT_PMSR and attribute
> > HWSIM_ATTR_PMSR_REQUEST. The attribute is formatted as the same way as
> > nl80211_pmsr_start() expects.

...

> > +		goto out_err;
> > +
> > +	pmsr = nla_nest_start(skb, HWSIM_ATTR_PMSR_REQUEST);
> > +	if (!pmsr) {
> > +		err = -ENOMEM;
> > +		goto out_err;
> > +	}
> > +
> > +	err = mac80211_hwsim_send_pmsr_request(skb, request);
> > +	if (err)
> 
> I think this error path needs to call nla_nest_cancel().

As per Johannes's comment elsewhere,
I now realise this is not necessary as the skb is destroyed.

...